<?php

namespace Teknisa\DF\Modules\Entrada\Factories;

use Doctrine\ORM\EntityManager;
    
class Dfe64000IntegracaoCFOPComTipoOperFactory {

    public function __construct(EntityManager $entityManager, $environment) {
        $this->connection   = $entityManager->getConnection();
        $this->environment  = $environment;
    }
    
    public function verificaCFOPUtilizado ($cdCFOP, $cdFilial, $dataSourceName) {
        
        if ($dataSourceName == "integracao_cfopxml_x_tipooperacao") {
            $sql = "SELECT CDTIPOOPER FROM CFOPXMLTPOPER
                     WHERE CDFISCOPER = :P_CDCFOP";
        
            $params = array(
                "P_CDCFOP"  => $cdCFOP 
            );
        }
        else {
            $sql = "SELECT CDTIPOOPERFIL AS CDTIPOOPER FROM CFOPXMLTPOPFIL
                     WHERE CDFISCOPERFIL = :P_CDCFOP AND CDFILIAL = :P_CDFILIAL";
        
            $params = array(
                "P_CDCFOP"  => $cdCFOP ,
                "P_CDFILIAL" => $cdFilial
            );
        }
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $cdTipoOper = $std->fetch();
        return ($cdTipoOper['CDTIPOOPER']);
    }
    
    public function save ($cdCFOP, $cdTipoOper, $cdFilial, $dataSourceName) {
        
        if ($dataSourceName == "integracao_cfopxml_x_tipooperacao") {
            $sql = "INSERT INTO CFOPXMLTPOPER (IDENTRSAIDOP, CDTIPOOPER, CDFISCOPER, NRORG)
                    VALUES ('E', :P_CDTIPOOPER, :P_CDCFOP, :P_NRORG)";

            $params = array (
                "P_CDTIPOOPER" => $cdTipoOper,
                "P_CDCFOP" => $cdCFOP,
                "P_NRORG" => $this->environment->getNrOrgTrab()
            );
        }
        else {
            $sql = "INSERT INTO CFOPXMLTPOPFIL (IDENTRSAIDOPFIL, CDFILIAL, CDTIPOOPERFIL, CDFISCOPERFIL, NRORG)
                    VALUES ('E', :P_CDFILIAL, :P_CDTIPOOPER, :P_CDCFOP, :P_NRORG)";

            $params = array (
                "P_CDTIPOOPER" => $cdTipoOper,
                "P_CDCFOP" => $cdCFOP,
                "P_NRORG" => $this->environment->getNrOrgTrab(),
                "P_CDFILIAL" => $cdFilial
            );
        }
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function delete ($cdCFOP, $cdFilial, $dataSourceName) {
        
        if ($dataSourceName == "integracao_cfopxml_x_tipooperacao") {
            $sql = "DELETE FROM CFOPXMLTPOPER
                     WHERE CDFISCOPER = :P_CDCFOP";
    
            $params = array (
                "P_CDCFOP" => $cdCFOP
            );
        }
        else {
            $sql = "DELETE FROM CFOPXMLTPOPFIL
                     WHERE CDFILIAL = :P_CDFILIAL
                       AND CDFISCOPERFIL = :P_CDCFOP";
    
            $params = array (
                "P_CDCFOP" => $cdCFOP,
                "P_CDFILIAL" => $cdFilial
            );
        }
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
}