<?php

namespace Teknisa\DF\Modules\Saida\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Filter;
use Teknisa\DF\Modules\Saida\Services\NotaFiscalDataUpdateService;
use Zeedhi\Framework\DataSource\ParameterBag;


class NotaFiscalDataUpdateController extends \Teknisa\DF\Controllers\TeknisaCrud {
    protected $dataSourceName = 'notafiscal_dataupdate';
    protected $NotaFiscalDataUpdateService;
    
    public function __construct($crudService, ParameterBag $parameterBag, NotaFiscalDataUpdateService $NotaFiscalDataUpdateService) {
        $this->NotaFiscalDataUpdateService = $NotaFiscalDataUpdateService;
        
        parent::__construct($crudService, $parameterBag);
    }

    public function find(Filter $request, Response $response) {
        $this-> dataSourceName;
        
        parent::find($request, $response);
    }
    
    public function save(Request $request, Response $response) {
        try {
            $rowsUpdate = $request->getRow()['rowsUpdate'];
            $newDate = $request->getRow()['newDate'];
            
            $statusUpdate = $this->NotaFiscalDataUpdateService->checkDataUpdate($rowsUpdate, $newDate);
            
            $response->addMessage(new Response\Message("Notas atualizadas com sucesso: ".$statusUpdate['notasAtualizadas'].". Notas com erro sem atualização: ".$statusUpdate['notasErros']."."));
        } catch(\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}